

Option Strict Off
Option Explicit On


Friend Class Form1


Inherits System.Windows.Forms.Form

	
Const PTN_SEPARATOR As String = ";" ' Pattern string separator
	

Private bLoaded As Boolean
Private bShowAlert As Boolean


Private Sub Form1_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
	
  On Error Resume Next
	
  Dim i As Short
  Dim sTmp As String = ""
	
	' Most controls in the Form are initialized to the values
	' of the Thumbnailer properties instead of reading them
	' in real time. If you change any properties in design time,
	' these controls may show incorrect values.
	
	' Fill the Thumbnail Borderstyle combobox
	With cboThumbBorderStyle
		Call .Items.Add("thoThinRaisedLight")
		Call .Items.Add("thoThinRaisedDark")
		Call .Items.Add("thoThinSunkenLight")
		Call .Items.Add("thoThinSunkenDark")
		Call .Items.Add("thoRaised")
		Call .Items.Add("thoSunken")
		Call .Items.Add("thoEtched")
		Call .Items.Add("thoBump")
		.SelectedIndex = Thumbnailer.ThumbBorderStyle
	End With
	
	' Fill the Thumbnail internal Borderstyle combobox
	With cboThumbBorderInStyle
		Call .Items.Add("thiNone")
		Call .Items.Add("thiThinRaisedLight")
		Call .Items.Add("thiThinRaisedDark")
		Call .Items.Add("thiThinSunkenLight")
		Call .Items.Add("thiThinSunkenDark")
		Call .Items.Add("thiRaised")
		Call .Items.Add("thiSunken")
		Call .Items.Add("thiEtched")
		Call .Items.Add("thiBump")
		.SelectedIndex = Thumbnailer.ThumbBorderInStyle
	End With
	
	' Fill the Label Borderstyle combobox
	With cboLabelBorderStyle
		Call .Items.Add("thoThinRaisedLight")
		Call .Items.Add("thoThinRaisedDark")
		Call .Items.Add("thoThinSunkenLight")
		Call .Items.Add("thoThinSunkenDark")
		Call .Items.Add("thoRaised")
		Call .Items.Add("thoSunken")
		Call .Items.Add("thoEtched")
		Call .Items.Add("thoBump")
		.SelectedIndex = Thumbnailer.LabelBorderStyle
	End With
	
	' Fill the Textboxes with the predefined values
	txtThumbWidth.Text = CStr(Thumbnailer.ThumbWidth)
	txtThumbHeight.Text = CStr(Thumbnailer.ThumbHeight)
	txtThumbOffset.Text = CStr(Thumbnailer.ThumbOffset)
	txtThumbSpace.Text = CStr(Thumbnailer.ThumbSpace)
	
	' Set the flag (set it to False to not get any Refresh messages)
	bShowAlert = False
	
	' Create the Thumbnailer.Pattern string
	' from the checked option buttons
	' --------------------------------------
	For i = 0 To 7
		If chkPtn(i).CheckState = System.Windows.Forms.CheckState.Checked Then
			sTmp = sTmp & chkPtn(i).Text & PTN_SEPARATOR
			' Add (*.jpeg) filetypes if (*.jpg) filetype is checked
			If i = 1 Then
				sTmp = sTmp & "*.jpeg" & PTN_SEPARATOR
			End If
		End If
	Next 
	' Thumbnailer will automatically remove any ending PTN_SEPARATOR
	' char from the Pattern string when processing it.
	' --------------------------------------
	
	' Set the Pattern
	Thumbnailer.Pattern = sTmp
	
	' Initialize info labels
	Call InitInfo()
	
	' This will cause any thumbnails to be drawn.
	Dir1.Path = My.Application.Info.DirectoryPath
	
	' Clear any printed events (PatternChange etc.)
	txtEvents.Text = vbNullString
					
	bLoaded = True

End Sub

' Although Thumbnailer handles any Escape key press and stops
' processing, it need to have the focus to do so.
' Escape key can be globaly handled by the app, if
' setting Form1.KeyPreview = True
Private Sub Form1_KeyDown(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown

  Dim KeyCode As Short = eventArgs.KeyCode
  Dim Shift As Short = eventArgs.KeyData \ &H10000
	
	' If Escape is pressed then stop any process in progress
	If KeyCode = System.Windows.Forms.Keys.Escape Then
		Call Thumbnailer.StopDraw()
	End If
	
End Sub

Private Sub Form1_Resize(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Resize
	
  On Error Resume Next
	
	If Me.WindowState = FormWindowState.Minimized Then Exit Sub

	' Resize controls
	Frame1.Width = Me.Width - Frame1.Left - 17
	Frame1.Height = Me.Height - Frame1.Top - 35
	Thumbnailer.Width = Frame1.Width - 17
	Thumbnailer.Height = Frame1.Height - 40
	PBar.Width = Frame1.Width - 17
	
End Sub



















Private Sub Drive1_SelectedIndexChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Drive1.SelectedIndexChanged
	
  On Error Resume Next ' To avoid "Drive not available" errors
	
	Dir1.Path = Drive1.Drive
	
End Sub

Private Sub Dir1_Change(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Dir1.Change
	
	' Initialize info labels
	Call InitInfo()
	
	' The Thumbnailer control does the Error handling
	' in the case of an invalid path.
	Thumbnailer.Path = Dir1.Path
	
	' Show information
	Call ShowInfo()
	
End Sub

' ThumbWidth (20 - 200 pixels)
' We set the property when the Enter key is pressed
Private Sub txtThumbWidth_KeyDown(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyEventArgs) Handles txtThumbWidth.KeyDown
	
  On Error Resume Next ' To avoid Overflow Errors in CInt()

  Dim KeyCode As Short = eventArgs.KeyCode
  Dim Shift As Short = eventArgs.KeyData \ &H10000
	
	If KeyCode = System.Windows.Forms.Keys.Return Then
		' Error handle
		' -------------------------
		If Not IsNumeric(txtThumbWidth.Text) Then
			txtThumbWidth.Text = "60"
			Else
			If CShort(txtThumbWidth.Text) < 20 Then txtThumbWidth.Text = CStr(20)
			If CShort(txtThumbWidth.Text) > 200 Then txtThumbWidth.Text = CStr(200)
		End If
		' -------------------------
		Thumbnailer.ThumbWidth = CShort(txtThumbWidth.Text)
		' Refresh the ThumbOffset label as it may be altered
		' when setting the Thumbnailer.ThumbWidth
		txtThumbOffset.Text = CStr(Thumbnailer.ThumbOffset)
	End If
	
End Sub

' ThumbWidth (20 - 200 pixels)
' If the textbox loses the focus we reset its value
Private Sub txtThumbWidth_Leave(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles txtThumbWidth.Leave
	
	' Refresh the label
	txtThumbWidth.Text = CStr(Thumbnailer.ThumbWidth)
	
End Sub

' ThumbHeight (20 - 200 pixels)
' We set the property when the Enter key is pressed
Private Sub txtThumbHeight_KeyDown(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyEventArgs) Handles txtThumbHeight.KeyDown
	
  On Error Resume Next ' To avoid Overflow Errors in CInt()

  Dim KeyCode As Short = eventArgs.KeyCode
  Dim Shift As Short = eventArgs.KeyData \ &H10000
	
	If KeyCode = System.Windows.Forms.Keys.Return Then
		' Error handle
		' -------------------------
		If Not IsNumeric(txtThumbHeight.Text) Then
			txtThumbHeight.Text = "60"
			Else
			If CShort(txtThumbHeight.Text) < 20 Then txtThumbHeight.Text = CStr(20)
			If CShort(txtThumbHeight.Text) > 200 Then txtThumbHeight.Text = CStr(200)
		End If
		' -------------------------
		Thumbnailer.ThumbHeight = CShort(txtThumbHeight.Text)
		' Refresh the ThumbOffset label as it may be altered
		' by setting the Thumbnailer.ThumbWidth
		txtThumbOffset.Text = CStr(Thumbnailer.ThumbOffset)
	End If
	
End Sub

' ThumbHeight (20 - 200 pixels)
' If the textbox loses the focus we reset its value
Private Sub txtThumbHeight_Leave(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles txtThumbHeight.Leave
	
	' Refresh the label
	txtThumbHeight.Text = CStr(Thumbnailer.ThumbHeight)
	
End Sub

' ThumbOffset (1 - 10 pixels)
' We set the property when the Enter key is pressed
Private Sub txtThumbOffset_KeyDown(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyEventArgs) Handles txtThumbOffset.KeyDown
	
  On Error Resume Next ' To avoid Overflow Errors in CInt()

  Dim KeyCode As Short = eventArgs.KeyCode
  Dim Shift As Short = eventArgs.KeyData \ &H10000
	
	If KeyCode = System.Windows.Forms.Keys.Return Then
		' Error handle
		' -------------------------
		If Not IsNumeric(txtThumbOffset.Text) Then
			txtThumbOffset.Text = "1"
			Else
			If CShort(txtThumbOffset.Text) < 1 Then txtThumbOffset.Text = CStr(1)
			If CShort(txtThumbOffset.Text) > 10 Then txtThumbOffset.Text = CStr(10)
		End If
		' -------------------------
		Thumbnailer.ThumbOffset = CShort(txtThumbOffset.Text)
		' Refresh the ThumbOffset label as it may be adjusted
		txtThumbOffset.Text = CStr(Thumbnailer.ThumbOffset)
	End If
	
End Sub

' ThumbOffset (1 - 10 pixels)
' If the textbox loses the focus we reset its value
Private Sub txtThumbOffset_Leave(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles txtThumbOffset.Leave
	
	' Refresh the label
	txtThumbOffset.Text = CStr(Thumbnailer.ThumbOffset)
	
End Sub

' ThumbSpace (1 - 20 pixels)
' We set the property when the Enter key is pressed
Private Sub txtThumbSpace_KeyDown(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyEventArgs) Handles txtThumbSpace.KeyDown
	
  On Error Resume Next ' To avoid Overflow Errors in CInt()

  Dim KeyCode As Short = eventArgs.KeyCode
  Dim Shift As Short = eventArgs.KeyData \ &H10000
	
	If KeyCode = System.Windows.Forms.Keys.Return Then
		' Error handle
		' -------------------------
		If Not IsNumeric(txtThumbSpace.Text) Then
			txtThumbSpace.Text = "1"
			Else
			If CShort(txtThumbSpace.Text) < 1 Then txtThumbSpace.Text = CStr(1)
			If CShort(txtThumbSpace.Text) > 20 Then txtThumbSpace.Text = CStr(20)
		End If
		' -------------------------
		Thumbnailer.ThumbSpace = CShort(txtThumbSpace.Text)
	End If
	
End Sub

' ThumbSpace (1 - 20 pixels)
' If the textbox loses the focus we set the property
Private Sub txtThumbSpace_Leave(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles txtThumbSpace.Leave
	
  On Error Resume Next ' To avoid Overflow Errors in CInt()
	
	If Not IsNumeric(txtThumbSpace.Text) Then
		txtThumbSpace.Text = "1"
		Else
		If CShort(txtThumbSpace.Text) < 1 Then txtThumbSpace.Text = CStr(1)
		If CShort(txtThumbSpace.Text) > 20 Then txtThumbSpace.Text = CStr(20)
	End If
	
	Thumbnailer.ThumbSpace = CShort(txtThumbSpace.Text)
	
End Sub

' Events logging
Private Sub txtEvents_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles txtEvents.TextChanged
	
  On Error Resume Next
	
  Dim iLength As Integer
						
	If Not bLoaded then Exit Sub

	iLength = Len(txtEvents.Text)
	
	' Clear the Textbox if its contents reaches 10000
	' characters to avoid "Out of memory" errors
	If iLength > 10000 Then txtEvents.Text = vbNullString
	
	' Force the txtEvents to show the last added line
	txtEvents.SelectionStart = iLength
	
End Sub

' ThumbBorderStyle
Private Sub cboThumbBorderStyle_SelectedIndexChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cboThumbBorderStyle.SelectedIndexChanged
					
	If Not bLoaded then Exit Sub

	Thumbnailer.ThumbBorderStyle = cboThumbBorderStyle.SelectedIndex
	
	' Refresh the ThumbOffset label as it may be altered
	' by setting the Thumbnailer.ThumbBorderStyle
	txtThumbOffset.Text = CStr(Thumbnailer.ThumbOffset)
	
	' The ThumbOffset property may be altered by the Thumbnailer
	' control internally when the ThumbWidth, ThumbHeight,
	' ThumbBorderStyle or the ThumbBorderInStyle are changed.
	' If the ThumbOffset is altered, then the Thumbnails must
	' be re-created and then re-drawn so the items are shown
	' correctly. As in most cases the ThumbOffset is not changed
	' we cheat here and just re-draw the items to have an instant
	' view of the effect. But remember, to see the final effect you
	' have to hit the Refresh button or to call the control's Redarw
	' method for a full refresh of the control.
	
	If bShowAlert Then
		Call MsgBox("Although you may get an idea about the effect, you have to hit Refresh to see the correct result." & vbCrLf & vbCrLf & "If you wish to no more receive this alert set the 'bShowAlert' to False in Form_Load.")
	End If
	
	' Re-draw
	Call Thumbnailer.DrawItems()
	
End Sub

' ThumbBorderInStyle
Private Sub cboThumbBorderInStyle_SelectedIndexChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cboThumbBorderInStyle.SelectedIndexChanged
					
	If Not bLoaded then Exit Sub

	Thumbnailer.ThumbBorderInStyle = cboThumbBorderInStyle.SelectedIndex
	
	' Refresh the ThumbOffset label as it may be altered
	' by setting the Thumbnailer.ThumbBorderInStyle
	txtThumbOffset.Text = CStr(Thumbnailer.ThumbOffset)
	
	' The ThumbOffset property may be altered by the Thumbnailer
	' control internally when the ThumbWidth, ThumbHeight,
	' ThumbBorderStyle or the ThumbBorderInStyle are changed.
	' If the ThumbOffset is altered, then the Thumbnails must
	' be re-created and then re-drawn so the items are shown
	' correctly. As in most cases the ThumbOffset is not changed
	' we cheat here and just re-draw the items to have an instant
	' view of the effect. But remember, to see the final effect you
	' have to hit the Refresh button or to call the control's Redarw
	' method for a full refresh of the control.
	
	If bShowAlert Then
		Call MsgBox("Although you may get an idea about the effect, you have to hit Refresh to see the correct result." & vbCrLf & vbCrLf & "If you wish to no more receive this alert set the 'bShowAlert' to False in Form_Load.")
	End If
	
	' Re-draw
	Call Thumbnailer.DrawItems()
	
End Sub

' LabelBorderStyle
Private Sub cboLabelBorderStyle_SelectedIndexChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cboLabelBorderStyle.SelectedIndexChanged
					
	If Not bLoaded then Exit Sub

	Thumbnailer.LabelBorderStyle = cboLabelBorderStyle.SelectedIndex
	
End Sub

' HasLabel
Private Sub chkPropHasLabel_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles chkPropHasLabel.CheckStateChanged
					
	If Not bLoaded then Exit Sub

	Thumbnailer.HasLabel = CBool(chkPropHasLabel.CheckState)
	
End Sub

' DragDrop
Private Sub chkPropDragDrop_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles chkPropDragDrop.CheckStateChanged
					
	If Not bLoaded then Exit Sub

	Thumbnailer.CtlDragDrop = CBool(chkPropDragDrop.CheckState)
	
	If Thumbnailer.CtlDragDrop Then
		Call MsgBox("True drag and drop functionality has been enabled", MsgBoxStyle.Information, "Notice")
	End If
	
End Sub

' LabelEdit
Private Sub chkPropLabelEdit_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles chkPropLabelEdit.CheckStateChanged
					
	If Not bLoaded then Exit Sub

	If chkPropLabelEdit.CheckState Then
		Thumbnailer.LabelEdit = ICThumbnailer.ethLabelEdit.thlAutomatic
		Else
		Thumbnailer.LabelEdit = ICThumbnailer.ethLabelEdit.thlManual
	End If
	
End Sub

Private Sub chkPropDelete_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles chkPropDelete.CheckStateChanged
					
	If Not bLoaded then Exit Sub

	Thumbnailer.CanDelete = CBool(chkPropDelete.CheckState)
	
End Sub

Private Sub chkPropFSO_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles chkPropFSO.CheckStateChanged
					
	If Not bLoaded then Exit Sub

	Thumbnailer.FSOEnable = CBool(chkPropFSO.CheckState)
	
	If Thumbnailer.FSOEnable Then
		Call MsgBox("When renaming or removing an item from Thumbnailer, the same action will take place on the corresponding file.", MsgBoxStyle.Information, "Notice")
	End If
	
End Sub

' Pattern
Private Sub chkPtn_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles chkPtn.CheckStateChanged
	
  Dim i As Short
  Dim sTmp As String = ""
  Dim Index As Short = chkPtn.GetIndex(eventSender)
				
	If Not bLoaded then Exit Sub
	
	' Create the Thumbnailer.Pattern string
	' from the checked option buttons
	' --------------------------------------
	For i = 0 To 7
		' Enable any previously disabled checkboxes
		chkPtn(i).Enabled = True
		' Add the extension to the Pattern string
		If chkPtn(i).CheckState = System.Windows.Forms.CheckState.Checked Then
			sTmp = sTmp & chkPtn(i).Text & PTN_SEPARATOR
			' Add (*.jpeg) filetypes if (*.jpg) filetype is checked
			If i = 1 Then
				sTmp = sTmp & "*.jpeg" & PTN_SEPARATOR
			End If
		End If
	Next 
	' Thumbnailer will automatically remove any ending PTN_SEPARATOR
	' char from the Pattern string when processing it.
	' --------------------------------------
	
	' An empty Pattern string, although it is allowed, it is ignored
	' by the control and does not change the existing Thumbnailer.Pattern
	' --------------------------------------
	' If only one Checkbox is left checked
	If (chkPtn(0).CheckState + chkPtn(1).CheckState + chkPtn(2).CheckState + chkPtn(3).CheckState + chkPtn(4).CheckState + chkPtn(5).CheckState + chkPtn(6).CheckState + chkPtn(7).CheckState) = 1 Then
		' Loop all the checkboxes
		For i = 0 To 7
			' Find the checked one
			If chkPtn(i).CheckState = System.Windows.Forms.CheckState.Checked Then
				' Do not allow it to be unchecked, as the current Pattern
				' for the Thumbnailer will not actually change, if the string is empty.
				chkPtn(i).Enabled = False
			End If
		Next 
	End If
	' --------------------------------------
	
	' Set the Pattern
	Thumbnailer.Pattern = sTmp
	
	' Refresh Thumbnailer and show updated info
	Call RefreshAll()
	
End Sub

' ShowHidden files
Private Sub chkPropHidden_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles chkPropHidden.CheckStateChanged
					
	If Not bLoaded then Exit Sub

	Thumbnailer.ShowHidden = CBool(chkPropHidden.CheckState)
	
	' Refresh Thumbnailer and show updated info
	Call RefreshAll()
	
End Sub

' ShowSystem files
Private Sub chkPropSystem_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles chkPropSystem.CheckStateChanged
					
	If Not bLoaded then Exit Sub

	Thumbnailer.ShowSystem = CBool(chkPropSystem.CheckState)
	
	' Refresh Thumbnailer and show updated info
	Call RefreshAll()
	
End Sub

' ReadOnly files
Private Sub chkPropReadOnly_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles chkPropReadOnly.CheckStateChanged
					
	If Not bLoaded then Exit Sub

	Thumbnailer.ShowReadOnly = CBool(chkPropReadOnly.CheckState)
	
	' Refresh Thumbnailer and show updated info
	RefreshAll()
	
End Sub

' Tooltips (filenames)
Private Sub chkPropTooltips_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles chkPropTooltips.CheckStateChanged
					
	If Not bLoaded then Exit Sub

	Thumbnailer.Tooltips = CBool(chkPropTooltips.CheckState)
	
End Sub

' Log events
Private Sub chkEvents_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles chkEvents.CheckStateChanged
					
	If Not bLoaded then Exit Sub

	chkEventsAll.Enabled = CBool(chkEvents.CheckState)
	
End Sub

' Back color
Private Sub cmdBkColor_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdBkColor.Click
	
  On Error GoTo Out ' To handle "Cancel pressed"
	
	DlgColor.FullOpen = True
	DlgColor.Color = Thumbnailer.CtlBackColor
	Call DlgColor.ShowDialog()
	
	' Set the color of the control's background
	Thumbnailer.CtlBackColor = DlgColor.Color
	
	' Cancel was pressed
Out: 
	
End Sub

' Items' Back color
Private Sub cmdBkItemColor_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdBkItemColor.Click
	
  On Error GoTo Out ' To handle "Cancel pressed"
	
	DlgColor.FullOpen = True
	DlgColor.Color = Thumbnailer.CtlBackColor
	Call DlgColor.ShowDialog()
	
	' Set the background color of the items
	Thumbnailer.BackClrItem = DlgColor.Color
	
	' Re-create the Thumbnails
	Call Thumbnailer.Redraw()
	
	' Cancel was pressed
Out: 
	
End Sub

' Set Selected item (Thumbnailer does the Error handling and on Error
' will set Thumbnailer.SelectedItem = Nothing)
Private Sub cmdSetSelected_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdSetSelected.Click
	
  On Error Resume Next ' To avoid Overflow Errors in CInt()
	
	' If we set the SelectedItem by index (as sorted)
	If IsNumeric(txtSelected.Text) Then
		' Set the selected item. Index must be < 32767 (Integer)
		Thumbnailer.SelectedItem = Thumbnailer.Thumbs(CShort(txtSelected.Text))
		' If we set the SelectedItem by Name
		Else
		' Set the selected item
		Thumbnailer.SelectedItem = Thumbnailer.Thumbs(txtSelected.Text)
	End If
	
	' Verify the current Selected Item's name, in txtSelected
	If Thumbnailer.SelectedItem Is Nothing Then
		txtSelected.Text = "<Nothing>"
		Else
		txtSelected.Text = Thumbnailer.SelectedItem.Name
	End If
	
End Sub

' Exports the SelectedItem as a BMP file in the application's Path
Private Sub cmdExport_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdExport.Click
	
  Dim eExport As ICThumbnailer.ethExportStyles
	
	' Set the export style
	If optExport(0).Checked Then
		eExport = ICThumbnailer.ethExportStyles.theClear
		Else
		eExport = ICThumbnailer.ethExportStyles.theFull
	End If
	
	' If there is any SelectedItem
	If Not (Thumbnailer.SelectedItem Is Nothing) Then
		If Thumbnailer.ExportThumb(Thumbnailer.SelectedItem.Name, My.Application.Info.DirectoryPath & "\thumbnail.bmp", eExport) Then
			Call MsgBox("Successfully exported in """ & My.Application.Info.DirectoryPath & """ as ""thumbnail.bmp"".", MsgBoxStyle.Critical, "Export item")
			Else
			Call MsgBox("Failed", MsgBoxStyle.Critical, "Export item")
		End If
	End If
	
End Sub

' Re-scans the Path, re-creates the Thumbnails and re-draws them
Private Sub cmdRefresh_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdRefresh.Click
	
	' Refresh Thumbnailer and show updated info
	Call RefreshAll()
	
End Sub

' Clear the txtEvents
Private Sub cmdClear_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdClear.Click
	
	txtEvents.Text = vbNullString
	
End Sub

' Shows information for the item specified in txtItemInfo
Private Sub cmdItemInfo_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdItemInfo.Click
	
  Dim oThumb As ICThumbnailer.Thumb
	
	' If the specified item does not exist, exit
	If Thumbnailer.Thumbs(txtItemInfo.Text) Is Nothing Then Exit Sub
	
	' Get a reference of the item
	oThumb = Thumbnailer.Thumbs(txtItemInfo.Text)
	
	' Show the dialog with the SelectedItem's info
	With oThumb
		' Always retrieved
		frmItemInfo.imgPreview.Image = System.Drawing.Image.FromFile(.Path & .Name)
		frmItemInfo.lblInfo(0).Text = .Name
		frmItemInfo.lblInfo(1).Text = .Path
		frmItemInfo.lblInfo(8).Text = CStr(.Selected)
		' To be retrieved, the appropriate property
		' must be set to True
		If Thumbnailer.CtlGetType Then
			frmItemInfo.lblInfo(2).Text = .FileType
			Else
			frmItemInfo.lblInfo(2).Text = "Not retrieved"
		End If
		If Thumbnailer.GetSize Then
			frmItemInfo.lblInfo(3).Text = CStr(.Size)
			Else
			frmItemInfo.lblInfo(3).Text = "Not retrieved"
		End If
		If Thumbnailer.GetDate Then
			frmItemInfo.lblInfo(4).Text = .DateMdf
			Else
			frmItemInfo.lblInfo(4).Text = "Not retrieved"
		End If
		If Thumbnailer.GetDims Then
			frmItemInfo.lblInfo(5).Text = CStr(.Width)
			frmItemInfo.lblInfo(6).Text = CStr(.Height)
			Else
			frmItemInfo.lblInfo(5).Text = "Not retrieved"
			frmItemInfo.lblInfo(6).Text = "Not retrieved"
		End If
		If Thumbnailer.GetExt Then
			frmItemInfo.lblInfo(7).Text = .Extension
			Else
			frmItemInfo.lblInfo(7).Text = "Not retrieved"
		End If
	End With
	
	' Show the dialog
	Call frmItemInfo.ShowDialog(Me)
	
End Sub

' Sort menu
Public Sub mnuSort_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuSort.Click
	
  Dim i As Integer
  Dim Index As Short = mnuSort.GetIndex(eventSender)
	
	' Initialize
	For i = 0 To 5
		mnuSort(i).Checked = False
	Next 
	
	' Check the clicked one
	mnuSort(Index).Checked = True
	
	' Set the property
	Thumbnailer.Sorted = Index
	
End Sub

Public Sub mnuSortOrder_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuSortOrder.Click
	
  Dim i As Integer
  Dim Index As Short = mnuSortOrder.GetIndex(eventSender)
	
	' Initialize
	For i = 0 To 1
		mnuSortOrder(i).Checked = False
	Next 
	
	' Check the clicked one
	mnuSortOrder(Index).Checked = True
	
	' Set the property
	Thumbnailer.SortOrder = Index
	
End Sub




























' ################## PROCEDURES ###################

' Initializes info controls
Private Sub InitInfo()
	
	' Initialize
	lblItems.Text = vbNullString
	lblLastDrawn.Text = vbNullString
	txtSelected.Text = vbNullString
	txtItemInfo.Text = vbNullString
	
End Sub

' Shows information
Private Sub ShowInfo()
	
  On Error Resume Next
	
	' Show information
	' --------------------------------------
	With Thumbnailer
		' Show the amount of items in the path
		lblItems.Text = CStr(.Items)
		' Show the current Selected Item's name in txtSelected
		If .SelectedItem Is Nothing Then
			txtSelected.Text = "<Nothing>"
			Else
			txtSelected.Text = .SelectedItem.Name
			' Optionally set it also, as the item to retrieve info for
			txtItemInfo.Text = txtSelected.Text
		End If
	End With
	' --------------------------------------
	
End Sub

' Refreshes Thumbnailer and shows updated info
Private Sub RefreshAll()
	
	' Initialize info labels
	Call InitInfo()
	
	' Re-create the Thumbnails
	Call Thumbnailer.Redraw()
	
	' Show information
	Call ShowInfo()
	
End Sub




























' ################## THUMBNAILER EVENTS ###################

Private Sub Thumbnailer_MouseMoveEvent(ByVal eventSender As System.Object, ByVal eventArgs As AxICThumbnailer.__Thumbnailer_MouseMoveEvent) Handles Thumbnailer.MouseMoveEvent
	
	' Uncomment below to test the HitTest function
	' Results are printed in the Immediate window
	' -------------------------------------------
 ' Dim sTemp As String = ""
 ' Dim THHI As ICThumbPlus.THHITTESTINFO
 ' Dim oThumb As ICThumbPlus.Thumb

 '   ' Get the item the mouse moves over
 '   oThumb = Thumbnailer.HitTest(eventArgs.X, eventArgs.Y, THHI)

 '   If oThumb Is Nothing Then
 '       Debug.Print("None")
 '       Else
 '       Select Case THHI
 '           Case ICThumbPlus.THHITTESTINFO.THT_ONICON
 '               sTemp = "On icon"
 '           Case ICThumbPlus.THHITTESTINFO.THT_ONLABEL
 '               sTemp = "On label"
 '           Case ICThumbPlus.THHITTESTINFO.THT_ONSTATE
 '               sTemp = "On checkbox"
 '       End Select
 '       Debug.Print(oThumb.Name & " (" & sTemp & ")")
 '	 End If
	' -------------------------------------------
	
	' Log the event
	If chkEvents.CheckState And chkEventsAll.CheckState Then
		txtEvents.Text = txtEvents.Text & "MouseMove " & eventArgs.Button & " , " & eventArgs.Shift & " , " & eventArgs.X & " , " & eventArgs.Y & vbCrLf
		Call txtEvents.ScrollToCaret
	End If
	
End Sub

Private Sub Thumbnailer_MouseDownEvent(ByVal eventSender As System.Object, ByVal eventArgs As AxICThumbnailer.__Thumbnailer_MouseDownEvent) Handles Thumbnailer.MouseDownEvent
	
	' Log the event
	If chkEvents.CheckState Then
		' If the Thumb has been set
		If Not eventArgs.Thumb Is Nothing Then
			txtEvents.Text = txtEvents.Text & "MouseDown " & eventArgs.Thumb.Name & ", " & eventArgs.Button & ", " & eventArgs.Shift & ", " & eventArgs.X & ", " & eventArgs.Y & vbCrLf
			' If the Thumb has not been set
			Else
			txtEvents.Text = txtEvents.Text & "MouseDown on empty area" & ", " & eventArgs.Button & ", " & eventArgs.Shift & ", " & eventArgs.X & ", " & eventArgs.Y & vbCrLf
		End If
		Call txtEvents.ScrollToCaret
	End If
	
End Sub

Private Sub Thumbnailer_MouseUpEvent(ByVal eventSender As System.Object, ByVal eventArgs As AxICThumbnailer.__Thumbnailer_MouseUpEvent) Handles Thumbnailer.MouseUpEvent
	
	' Log the event
	If chkEvents.CheckState Then
		' If the Thumb is set
		If Not eventArgs.Thumb Is Nothing Then
			txtEvents.Text = txtEvents.Text & "MouseUp " & eventArgs.Thumb.Name & ", " & eventArgs.Button & ", " & eventArgs.Shift & ", " & eventArgs.X & ", " & eventArgs.Y & vbCrLf
			' If the Thumb is not set
			Else
			txtEvents.Text = txtEvents.Text & "MouseUp on empty area" & ", " & eventArgs.Button & ", " & eventArgs.Shift & ", " & eventArgs.X & ", " & eventArgs.Y & vbCrLf
		End If
		Call txtEvents.ScrollToCaret
		' If the Right button is clicked
		If eventArgs.Button And VB6.MouseButtonConstants.RightButton Then
			' Enable the Sort menus that we have the needed info
			If Thumbnailer.CtlGetType Then mnuSort(1).Enabled = True
			If Thumbnailer.GetSize Then mnuSort(2).Enabled = True
			If Thumbnailer.GetDate Then mnuSort(3).Enabled = True
			If Thumbnailer.GetDims Then mnuSort(4).Enabled = True
			If Thumbnailer.GetExt Then mnuSort(5).Enabled = True
			' Check the active Sort menu
			mnuSort(Thumbnailer.Sorted).Checked = True
			' Check the active SortOrder menu
			mnuSortOrder(Thumbnailer.SortOrder).Checked = True
			' Show the Sort menu
			Call mnuRight.Show(Cursor.Position.X, Cursor.Position.y)
		End If
	End If
	
End Sub

Private Sub Thumbnailer_ClickEvent(ByVal eventSender As System.Object, ByVal eventArgs As AxICThumbnailer.__Thumbnailer_ClickEvent) Handles Thumbnailer.ClickEvent
	
	' Log the event
	If chkEvents.CheckState Then
		' If the Thumb has been set
		If Not eventArgs.Thumb Is Nothing Then
			txtEvents.Text = txtEvents.Text & "Click " & eventArgs.Thumb.Name & vbCrLf
			' If the Thumb has not been set
			Else
			txtEvents.Text = txtEvents.Text & "Click on empty area" & vbCrLf
		End If
		Call txtEvents.ScrollToCaret
	End If
	
End Sub

Private Sub Thumbnailer_DblClick(ByVal eventSender As System.Object, ByVal eventArgs As AxICThumbnailer.__Thumbnailer_DblClickEvent) Handles Thumbnailer.DblClick
	
	' Log the event
	If chkEvents.CheckState Then
		' If the Thumb has been set
		If Not eventArgs.Thumb Is Nothing Then
			txtEvents.Text = txtEvents.Text & "DblClick " & eventArgs.Thumb.Name & vbCrLf
			' If the Thumb has not been set
			Else
			txtEvents.Text = txtEvents.Text & "DblClick on empty area" & vbCrLf
		End If
		Call txtEvents.ScrollToCaret
	End If
	
End Sub

' Raised before the Path changes and the image files been validated, allowing
' the user to prevent the Path from changing, by setting Cancel = True.
Private Sub Thumbnailer_BeforePathChange(ByVal eventSender As System.Object, ByVal eventArgs As AxICThumbnailer.__Thumbnailer_BeforePathChangeEvent) Handles Thumbnailer.BeforePathChange
	
	' Cancel = True
	
End Sub

' Raised after the image files have been validated and the
' final Items property has been set.
Private Sub Thumbnailer_AfterPathChange(ByVal eventSender As System.Object, ByVal eventArgs As AxICThumbnailer.__Thumbnailer_AfterPathChangeEvent) Handles Thumbnailer.AfterPathChange
	
	' Log the event
	If chkEvents.CheckState Then
		txtEvents.Text = txtEvents.Text & "PathChange" & vbCrLf
		Call txtEvents.ScrollToCaret
	End If
	
End Sub

Private Sub Thumbnailer_AfterListChange(ByVal eventSender As System.Object, ByVal eventArgs As AxICThumbnailer.__Thumbnailer_AfterListChangeEvent) Handles Thumbnailer.AfterListChange
	
	' Log the event
	If chkEvents.CheckState Then
		txtEvents.Text = txtEvents.Text & "ListChange" & vbCrLf
		Call txtEvents.ScrollToCaret
	End If
	
End Sub

Private Sub Thumbnailer_AfterPatternChange(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Thumbnailer.AfterPatternChange
	
	' Log the event
	If chkEvents.CheckState Then
		txtEvents.Text = txtEvents.Text & "AfterPatternChange" & vbCrLf
		Call txtEvents.ScrollToCaret
	End If
	
End Sub

' Raised when the Items property of the control is changed due to
' detection of invalid items.
Private Sub Thumbnailer_ItemsCountChange(ByVal eventSender As System.Object, ByVal eventArgs As AxICThumbnailer.__Thumbnailer_ItemsCountChangeEvent) Handles Thumbnailer.ItemsCountChange
	
	' Set the Progress Bar's Max property
	If eventArgs.ItemsCount > 0 Then
		PBar.Maximum = eventArgs.ItemsCount
		Else
		PBar.Value = 0
	End If
	
End Sub

' Raised each time a Thumb for a valid file
' has been added to the collection.
Private Sub Thumbnailer_AfterThumbAdd(ByVal eventSender As System.Object, ByVal eventArgs As AxICThumbnailer.__Thumbnailer_AfterThumbAddEvent) Handles Thumbnailer.AfterThumbAdd
	
	' Log the event
 '	If chkEvents.CheckState Then
 '      txtEvents.Text = txtEvents.Text & "AfterThumbAdd (Index = " & eventArgs.Index & ")" & vbCrLf
 '		Call txtEvents.ScrollToCaret
 '  End If
	
	' Show the current drawn thumbnail's index
	lblLastDrawn.Text = CStr(eventArgs.Index)
	
	' Increase the Progress Bar as soon as a new thumbnail is added
	PBar.Value = eventArgs.Index
	
	' PBar.Max has been set in ItemsCountChange event
	
	' We may reset the ProgBar when finished
	' here or in ThumbsAdded event
	'If Index = PBar.Max Then PBar.Value = 0
	
End Sub

' Thumbnails creation has been finished
Private Sub Thumbnailer_ThumbsAdded(ByVal eventSender As System.Object, ByVal eventArgs As AxICThumbnailer.__Thumbnailer_ThumbsAddedEvent) Handles Thumbnailer.ThumbsAdded
	
	' Reset the ProgBar
	PBar.Value = 0
	
End Sub

' The event is raised only if the mouse moves over an item.
' Thumb can not be Nothing
Private Sub Thumbnailer_HitTestEvent(ByVal eventSender As System.Object, ByVal eventArgs As AxICThumbnailer.__Thumbnailer_HitTestEvent) Handles Thumbnailer.HitTestEvent
	
	' Log the event
	If chkEventsAll.CheckState Then
		txtEvents.Text = txtEvents.Text & "HitTest (" & eventArgs.Thumb.Name & ")" & vbCrLf
		Call txtEvents.ScrollToCaret
	End If
	
End Sub

' SelectedItem has been changed
Private Sub Thumbnailer_SelChanged(ByVal eventSender As System.Object, ByVal eventArgs As AxICThumbnailer.__Thumbnailer_SelChangedEvent) Handles Thumbnailer.SelChanged
	
	' Log the event
	If chkEvents.CheckState Then
		txtEvents.Text = txtEvents.Text & "SelChanged (" & eventArgs.Thumb.Name & ")" & vbCrLf
		Call txtEvents.ScrollToCaret
	End If
	
	' Show the info for the item
	txtSelected.Text = eventArgs.Thumb.Name
	' Optionally, set it as the item to retrieve info for
	txtItemInfo.Text = txtSelected.Text
	
End Sub

' An item has been added
Private Sub Thumbnailer_ItemAdd(ByVal eventSender As System.Object, ByVal eventArgs As AxICThumbnailer.__Thumbnailer_ItemAddEvent) Handles Thumbnailer.ItemAdd
	
	' Log the event
	If chkEvents.CheckState Then
		txtEvents.Text = txtEvents.Text & "ItemAdd (" & eventArgs.Thumb.Name & ")" & vbCrLf
		Call txtEvents.ScrollToCaret
	End If
	
	' Initialize info labels
	Call InitInfo()
	
	' Refresh info
	Call ShowInfo()
	
End Sub

' An item has been renamed
Private Sub Thumbnailer_ItemRename(ByVal eventSender As System.Object, ByVal eventArgs As AxICThumbnailer.__Thumbnailer_ItemRenameEvent) Handles Thumbnailer.ItemRename
	
	' Log the event
	If chkEvents.CheckState Then
		txtEvents.Text = txtEvents.Text & "ItemRename (" & eventArgs.sOldName & ", " & eventArgs.Thumb.Name & ")" & vbCrLf
		Call txtEvents.ScrollToCaret
	End If
	
	' Initialize info labels
	Call InitInfo()
	
	' Refresh info
	Call ShowInfo()
	
End Sub

Private Sub Thumbnailer_ItemDelete(ByVal eventSender As System.Object, ByVal eventArgs As AxICThumbnailer.__Thumbnailer_ItemDeleteEvent) Handles Thumbnailer.ItemDelete
	
	' Log the event
	If chkEvents.CheckState Then
		txtEvents.Text = txtEvents.Text & "ItemDelete (" & eventArgs.sName & ")" & vbCrLf
		Call txtEvents.ScrollToCaret
	End If
	
	' Initialize info labels
	InitInfo()
	
	' Refresh info
	ShowInfo()
	
End Sub

Private Sub Thumbnailer_ItemsDeleted(ByVal eventSender As System.Object, ByVal eventArgs As AxICThumbnailer.__Thumbnailer_ItemsDeletedEvent) Handles Thumbnailer.ItemsDeleted
	
	' Log the event
	If chkEvents.CheckState Then
		txtEvents.Text = txtEvents.Text & "ItemsDeleted (" & eventArgs.ItemsCount & ")" & vbCrLf
		Call txtEvents.ScrollToCaret
	End If
	
End Sub

' Thumb can not be = Nothing
Private Sub Thumbnailer_BeforeLabelEdit(ByVal eventSender As System.Object, ByVal eventArgs As AxICThumbnailer.__Thumbnailer_BeforeLabelEditEvent) Handles Thumbnailer.BeforeLabelEdit
	
	' Log the event
	If chkEvents.CheckState Then
		txtEvents.Text = txtEvents.Text & "BeforeLabelEdit (" & eventArgs.Thumb.Name & ")" & vbCrLf
		Call txtEvents.ScrollToCaret
	End If
	
End Sub

' Thumb can not be = Nothing
Private Sub Thumbnailer_AfterLabelEdit(ByVal eventSender As System.Object, ByVal eventArgs As AxICThumbnailer.__Thumbnailer_AfterLabelEditEvent) Handles Thumbnailer.AfterLabelEdit
	
  Dim sText As String
	
	' Set bCancel = True to cancel the event and
	' prevent text from being changed.
	
	' Log the event
	If chkEvents.CheckState Then
		' If the NewText is empty, then either the Label editing has been
		' canceled by pressing the ESC key or the label is not changed.
		' If empty text is applied, the label resets to its original text.
		If Len(eventArgs.NewText) = 0 Then ' or bCancel
			sText = "NULL"
			Else
			sText = eventArgs.NewText
		End If
		txtEvents.Text = txtEvents.Text & "AfterLabelEdit (" & eventArgs.Thumb.Name & "), " & sText & vbCrLf
		Call txtEvents.ScrollToCaret
	End If
	
End Sub

' Operation has been interrupted
Private Sub Thumbnailer_Interrupted(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Thumbnailer.Interrupted
	
	' Reset the Progress Bar
	PBar.Value = 0
	
	' Log the event
	If chkEvents.CheckState Then
		txtEvents.Text = txtEvents.Text & "Interrupted" & vbCrLf
		Call txtEvents.ScrollToCaret
	End If
	
End Sub

' DropEffect determines the allowed action
'UPGRADE_ISSUE: VBRUN.DataObject type was not upgraded. Click for more: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6B85A2A7-FE9F-4FBE-AA0C-CF11AC86A305"'
Private Sub Thumbnailer_ItemsStartDrag(ByVal eventSender As System.Object, ByVal eventArgs As AxICThumbnailer.__Thumbnailer_ItemsStartDragEvent) Handles Thumbnailer.ItemsStartDrag
	
  On Error Resume Next
	
  Dim iItems As Integer ' Number of items in the collection
	
	' Get the number of items in the Data.Files collection
	iItems = eventArgs.Data.Files.Count
	
	' Log the event
	If chkEvents.CheckState Then
		txtEvents.Text = txtEvents.Text & "ItemsStartDrag (" & iItems & "), " & eventArgs.DropEffect & vbCrLf
		Call txtEvents.ScrollToCaret
	End If
	
End Sub

' DropEffect determines the allowed action
Private Sub Thumbnailer_ItemsDragOver(ByVal eventSender As System.Object, ByVal eventArgs As AxICThumbnailer.__Thumbnailer_ItemsDragOverEvent) Handles Thumbnailer.ItemsDragOver
	
  On Error Resume Next
	
  Dim iItems As Integer ' Number of items in the collection
	
	' Get the number of items in the Data.Files collection
	iItems = eventArgs.Data.Files.Count
	
	' Log the event
	'    If chkEvents Then
	'        txtEvents = txtEvents & "ItemsDragOver (" & iItems & "), " & DropEffect & ", " & Button & ", " & Shift & ", " & X & ", " & Y & ", " & State & vbCrLf
	'	     Call txtEvents.ScrollToCaret
	'    End If
	
End Sub

' External item(s) have been dropped onto the control
Private Sub Thumbnailer_ItemsDragDrop(ByVal eventSender As System.Object, ByVal eventArgs As AxICThumbnailer.__Thumbnailer_ItemsDragDropEvent) Handles Thumbnailer.ItemsDragDrop
	
  Dim iItems As Integer ' Number of items in the collection
	
	' Get the number of items in the Data.Files collection
	iItems = eventArgs.Data.Files.Count
	
	' Log the event
	If chkEvents.CheckState Then
		txtEvents.Text = txtEvents.Text & "ItemsDragDrop (" & iItems & "), " & eventArgs.DropEffect & vbCrLf
		Call txtEvents.ScrollToCaret
	End If
	
	' Although the control handles Copy or Move operations, it
	' does not refresh automatically as new items are added to
	' the current Path after a drop operation (Copy or Move).
	' So we have to manually Refresh.
	
	' As the system needs time to finish any Copy or Move
	' operation, we can not just call Redraw here because the
	' operation may not be completed.
	
End Sub

' Internal item(s) have been dropped outside the control
Private Sub Thumbnailer_ItemsCompleteDrag(ByVal eventSender As System.Object, ByVal eventArgs As AxICThumbnailer.__Thumbnailer_ItemsCompleteDragEvent) Handles Thumbnailer.ItemsCompleteDrag
	
	' Log the event
	If chkEvents.CheckState Then
		txtEvents.Text = txtEvents.Text & "ItemsCompleteDrag (" & eventArgs.DropEffect & ")" & vbCrLf
		Call txtEvents.ScrollToCaret
	End If
	
	' Although the control handles Copy or Move operations, it does
	' not refresh automatically when new items are removed from the
	' current Path after a drag and drop operation (Move).
	' So we have to manually Refresh.
	
	' As the system needs time to finish any Copy or Move
	' operation, we can not just call Redraw here because the
	' operation may not be completed.
	
End Sub


End Class